import math


# 1
def dsa1_reverse(s,n):
	s1 = s[-n:]
	s2 = s[0:-n]
	s = s1 + s2
	return s


# 2
def dsa1_factorialSum(n):
	fsum = 0
	for i in range(1, n + 1):
		fsum += math.factorial(i)
	return fsum


#3
def dsa1_generateDict(keys, values):
	dic = {}
	l = len(keys)
	for i in range(l):
		dic[keys[i]] = values[i]
	return dic


#4
def dsa1_en2num(s):
	nums = s.split('-')
	word_num_dict = {'zero':0, 'one':1, 'two':2, 'three':3, 'four':4, 'five':5, 'six':6, 'seven':7, 'eight':8, 'nine':9}
	ret = 0
	for num in nums:
		ret = ret * 10 + word_num_dict[num]
	return ret


#5
def dsa1_getUnion(s1,s2):
	t1 = set(s1)
	t2 = set(s2)
	return t1 | t2


#6
def dsa1_getDays(y,m):
	month_day = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
	if m != 2:
		return month_day[m - 1]

	if (y % 4 == 0 and y % 100 != 0) or (y % 400 == 0):
		return month_day[1] + 1
	else:
		return month_day[1]


#7
def dsa1_isNarcNum(n):
	nums = []
	fsum = 0
	tn = n
	while n >= 10:
		nums.append(n % 10)
		n = n // 10
	nums.append(n)
	p = len(nums)
	
	for num in nums:
		fsum += pow(num, p)

	if fsum == tn:
		return True
	else:
		return False


#8
def dsa1_writeNarcNum(max):
	fp = open('narcissistic.txt', 'w')
	for i in range(100, max):
		if dsa1_isNarcNum(i) is True:
			fp.write(str(i) + '\n')
	fp.close()


#9
def dsa1_readNarcNum():
	narc_num = []
	with open('narcissistic.txt', 'r') as fp:
		nums = fp.readlines()
		for num in nums:
			num = int(num)
			narc_num.append(num)
	return narc_num


#10
def dsa1_printTri(n):
	print(1)
	pre = [1, 1]
	for i in range(1, n):
		for n in pre:
			print(str(n) + ' ', end='')
		print()
		pre.append(1)
		for i in range(i, 0, -1):
			pre[i] = pre[i] + pre[i-1]
	


if __name__ == '__main__':
	print(dsa1_reverse('abcd', 2))
	print(dsa1_factorialSum(3))
	print(dsa1_generateDict((1,2,3), ('abc','def','ghi')))
	print(dsa1_en2num('one-two-three-four-five'))
	print(dsa1_getUnion('abc','bcd'))
	print(dsa1_getDays(2004,2))
	print(dsa1_isNarcNum(153))
	dsa1_writeNarcNum(1000)
	print(dsa1_readNarcNum())
	dsa1_printTri(6)